diff -urN systemd-216/src/tmpfiles/tmpfiles.c systemd-217/src/tmpfiles/tmpfiles.c
--- systemd-216/src/tmpfiles/tmpfiles.c	2014-11-03 09:35:33.029227934 -0800
+++ systemd-217/src/tmpfiles/tmpfiles.c	2014-10-23 12:36:56.810756232 -0700
@@ -259,7 +259,7 @@
 
         /* got only one handle; assume different mount points if one
          * of both queries was not supported by the filesystem */
-        if (r_p == -ENOSYS || r_p == -ENOTSUP || r == -ENOSYS || r == -ENOTSUP)
+        if (r_p == -ENOSYS || r_p == -EOPNOTSUPP || r == -ENOSYS || r == -EOPNOTSUPP)
                 return true;
 
         /* return error */
@@ -509,9 +509,9 @@
                 i->type == TRUNCATE_FILE ? O_CREAT|O_TRUNC|O_NOFOLLOW : 0;
 
         RUN_WITH_UMASK(0000) {
-                label_context_set(path, S_IFREG);
+                mac_selinux_create_file_prepare(path, S_IFREG);
                 fd = open(path, flags|O_NDELAY|O_CLOEXEC|O_WRONLY|O_NOCTTY, i->mode);
-                label_context_clear();
+                mac_selinux_create_file_clear();
         }
 
         if (fd < 0) {
@@ -743,9 +743,9 @@
         case CREATE_FIFO:
 
                 RUN_WITH_UMASK(0000) {
-                        label_context_set(i->path, S_IFIFO);
+                        mac_selinux_create_file_prepare(i->path, S_IFIFO);
                         r = mkfifo(i->path, i->mode);
-                        label_context_clear();
+                        mac_selinux_create_file_clear();
                 }
 
                 if (r < 0) {
@@ -764,9 +764,9 @@
                                 if (i->force) {
 
                                         RUN_WITH_UMASK(0000) {
-                                                label_context_set(i->path, S_IFIFO);
+                                                mac_selinux_create_file_prepare(i->path, S_IFIFO);
                                                 r = mkfifo_atomic(i->path, i->mode);
-                                                label_context_clear();
+                                                mac_selinux_create_file_clear();
                                         }
 
                                         if (r < 0) {
@@ -788,9 +788,9 @@
 
         case CREATE_SYMLINK:
 
-                label_context_set(i->path, S_IFLNK);
+                mac_selinux_create_file_prepare(i->path, S_IFLNK);
                 r = symlink(i->argument, i->path);
-                label_context_clear();
+                mac_selinux_create_file_clear();
 
                 if (r < 0) {
                         _cleanup_free_ char *x = NULL;
@@ -804,9 +804,9 @@
                         if (r < 0 || !streq(i->argument, x)) {
 
                                 if (i->force) {
-                                        label_context_set(i->path, S_IFLNK);
+                                        mac_selinux_create_file_prepare(i->path, S_IFLNK);
                                         r = symlink_atomic(i->argument, i->path);
-                                        label_context_clear();
+                                        mac_selinux_create_file_clear();
 
                                         if (r < 0) {
                                                 log_error("symlink(%s, %s) failed: %s", i->argument, i->path, strerror(-r));
@@ -838,9 +838,9 @@
                 file_type = i->type == CREATE_BLOCK_DEVICE ? S_IFBLK : S_IFCHR;
 
                 RUN_WITH_UMASK(0000) {
-                        label_context_set(i->path, file_type);
+                        mac_selinux_create_file_prepare(i->path, file_type);
                         r = mknod(i->path, i->mode | file_type, i->major_minor);
-                        label_context_clear();
+                        mac_selinux_create_file_clear();
                 }
 
                 if (r < 0) {
@@ -865,9 +865,9 @@
                                 if (i->force) {
 
                                         RUN_WITH_UMASK(0000) {
-                                                label_context_set(i->path, file_type);
+                                                mac_selinux_create_file_prepare(i->path, file_type);
                                                 r = mknod_atomic(i->path, i->mode | file_type, i->major_minor);
-                                                label_context_clear();
+                                                mac_selinux_create_file_clear();
                                         }
 
                                         if (r < 0) {
@@ -1610,7 +1610,7 @@
 
         umask(0022);
 
-        label_init(NULL);
+        mac_selinux_init(NULL);
 
         items = hashmap_new(&string_hash_ops);
         globs = hashmap_new(&string_hash_ops);
@@ -1670,7 +1670,7 @@
 
         set_free_free(unix_sockets);
 
-        label_finish();
+        mac_selinux_finish();
 
         return r < 0 ? EXIT_FAILURE : EXIT_SUCCESS;
 }
diff -urN systemd-216/src/udev/cdrom_id/cdrom_id.c systemd-217/src/udev/cdrom_id/cdrom_id.c
--- systemd-216/src/udev/cdrom_id/cdrom_id.c	2014-08-11 10:56:20.745269015 -0700
+++ systemd-217/src/udev/cdrom_id/cdrom_id.c	2014-10-28 04:23:14.064133828 -0700
@@ -606,7 +606,7 @@
                 switch (feature) {
                 case 0x00:
                         log_debug("GET CONFIGURATION: feature 'profiles', with %i entries", features[i+3] / 4);
-                        feature_profiles(udev, &features[i]+4, features[i+3]);
+                        feature_profiles(udev, &features[i]+4, MIN(features[i+3], len - i - 4));
                         break;
                 default:
                         log_debug("GET CONFIGURATION: feature 0x%04x <ignored>, with 0x%02x bytes", feature, features[i+3]);
diff -urN systemd-216/src/udev/scsi_id/scsi_id.c systemd-217/src/udev/scsi_id/scsi_id.c
--- systemd-216/src/udev/scsi_id/scsi_id.c	2014-08-11 10:56:20.712269030 -0700
+++ systemd-217/src/udev/scsi_id/scsi_id.c	2014-11-03 09:33:49.172180743 -0800
@@ -317,8 +317,8 @@
                "  -f,--config=                     location of config file\n"
                "  -p,--page=0x80|0x83|pre-spc3-83  SCSI page (0x80, 0x83, pre-spc3-83)\n"
                "  -s,--sg-version=3|4              use SGv3 or SGv4\n"
-               "  -b,--blacklisted                 threat device as blacklisted\n"
-               "  -g,--whitelisted                 threat device as whitelisted\n"
+               "  -b,--blacklisted                 treat device as blacklisted\n"
+               "  -g,--whitelisted                 treat device as whitelisted\n"
                "  -u,--replace-whitespace          replace all whitespace by underscores\n"
                "  -v,--verbose                     verbose logging\n"
                "     --version                     print version\n"
diff -urN systemd-216/src/udev/udevadm.c systemd-217/src/udev/udevadm.c
--- systemd-216/src/udev/udevadm.c	2014-11-03 09:35:23.119128010 -0800
+++ systemd-217/src/udev/udevadm.c	2014-10-23 08:13:15.783717947 -0700
@@ -99,7 +99,7 @@
         log_parse_environment();
         log_open();
         udev_set_log_fn(udev, udev_main_log);
-        label_init("/dev");
+        mac_selinux_init("/dev");
 
         while ((c = getopt_long(argc, argv, "+dhV", options, NULL)) >= 0)
                 switch (c) {
@@ -137,7 +137,7 @@
         fprintf(stderr, "%s: missing or unknown command\n", program_invocation_short_name);
         rc = 2;
 out:
-        label_finish();
+        mac_selinux_finish();
         udev_unref(udev);
         log_close();
         return rc;
diff -urN systemd-216/src/udev/udevadm-hwdb.c systemd-217/src/udev/udevadm-hwdb.c
--- systemd-216/src/udev/udevadm-hwdb.c	2014-11-03 09:35:29.667194034 -0800
+++ systemd-217/src/udev/udevadm-hwdb.c	2014-10-28 06:31:25.105131602 -0700
@@ -536,14 +536,20 @@
 static void help(void) {
         printf("Usage: udevadm hwdb OPTIONS\n"
                "  -u,--update          update the hardware database\n"
+               "  --usr                generate in " UDEVLIBEXECDIR " instead of /etc/udev\n"
                "  -t,--test=MODALIAS   query database and print result\n"
                "  -r,--root=PATH       alternative root path in the filesystem\n"
                "  -h,--help\n\n");
 }
 
 static int adm_hwdb(struct udev *udev, int argc, char *argv[]) {
+        enum {
+                ARG_USR = 0x100,
+        };
+
         static const struct option options[] = {
                 { "update", no_argument,       NULL, 'u' },
+                { "usr",    no_argument,       NULL, ARG_USR },
                 { "test",   required_argument, NULL, 't' },
                 { "root",   required_argument, NULL, 'r' },
                 { "help",   no_argument,       NULL, 'h' },
@@ -551,6 +557,7 @@
         };
         const char *test = NULL;
         const char *root = "";
+        const char *hwdb_bin_dir = "/etc/udev";
         bool update = false;
         struct trie *trie = NULL;
         int err, c;
@@ -561,6 +568,9 @@
                 case 'u':
                         update = true;
                         break;
+                case ARG_USR:
+                        hwdb_bin_dir = UDEVLIBEXECDIR;
+                        break;
                 case 't':
                         test = optarg;
                         break;
@@ -634,7 +644,8 @@
                 log_debug("strings dedup'ed: %8zu bytes (%8zu)",
                           trie->strings->dedup_len, trie->strings->dedup_count);
 
-                if (asprintf(&hwdb_bin, "%s/etc/udev/hwdb.bin", root) < 0) {
+                hwdb_bin = strjoin(root, "/", hwdb_bin_dir, "/hwdb.bin", NULL);
+                if (!hwdb_bin) {
                         rc = EXIT_FAILURE;
                         goto out;
                 }
diff -urN systemd-216/src/udev/udev-builtin-path_id.c systemd-217/src/udev/udev-builtin-path_id.c
--- systemd-216/src/udev/udev-builtin-path_id.c	2014-08-04 09:58:23.609783740 -0700
+++ systemd-217/src/udev/udev-builtin-path_id.c	2014-11-03 09:33:48.620175178 -0800
@@ -332,7 +332,7 @@
         return parent;
 }
 
-static struct udev_device *handle_scsi(struct udev_device *parent, char **path) {
+static struct udev_device *handle_scsi(struct udev_device *parent, char **path, bool *supported_parent) {
         const char *devtype;
         const char *name;
         const char *id;
@@ -346,6 +346,7 @@
         if (id != NULL) {
                 parent = skip_subsystem(parent, "scsi");
                 path_prepend(path, "ieee1394-0x%s", id);
+                *supported_parent = true;
                 goto out;
         }
 
@@ -354,16 +355,19 @@
 
         if (strstr(name, "/rport-") != NULL) {
                 parent = handle_scsi_fibre_channel(parent, path);
+                *supported_parent = true;
                 goto out;
         }
 
         if (strstr(name, "/end_device-") != NULL) {
                 parent = handle_scsi_sas(parent, path);
+                *supported_parent = true;
                 goto out;
         }
 
         if (strstr(name, "/session") != NULL) {
                 parent = handle_scsi_iscsi(parent, path);
+                *supported_parent = true;
                 goto out;
         }
 
@@ -502,7 +506,7 @@
                 } else if (streq(subsys, "scsi_tape")) {
                         handle_scsi_tape(parent, &path);
                 } else if (streq(subsys, "scsi")) {
-                        parent = handle_scsi(parent, &path);
+                        parent = handle_scsi(parent, &path, &supported_parent);
                         supported_transport = true;
                 } else if (streq(subsys, "cciss")) {
                         parent = handle_cciss(parent, &path);
@@ -544,9 +548,9 @@
         }
 
         /*
-         * Do return devices with have an unknown type of parent device, they
-         * might produce conflicting IDs below multiple independent parent
-         * devices.
+         * Do not return devices with an unknown parent device type. They
+         * might produce conflicting IDs if the parent does not provide a
+         * unique and predictable name.
          */
         if (!supported_parent) {
                 free(path);
@@ -554,9 +558,9 @@
         }
 
         /*
-         * Do not return a have-only a single-parent block devices, some
-         * have entire hidden buses behind it, and not create predictable
-         * IDs that way.
+         * Do not return block devices without a well-known transport. Some
+         * devices do not expose their buses and do not provide a unique
+         * and predictable name that way.
          */
         if (streq(udev_device_get_subsystem(dev), "block") && !supported_transport) {
                 free(path);
diff -urN systemd-216/src/udev/udevd.c systemd-217/src/udev/udevd.c
--- systemd-216/src/udev/udevd.c	2014-11-03 09:35:29.778195153 -0800
+++ systemd-217/src/udev/udevd.c	2014-10-23 08:13:15.784717951 -0700
@@ -1139,7 +1139,7 @@
                 goto exit;
         }
 
-        r = label_init("/dev");
+        r = mac_selinux_init("/dev");
         if (r < 0) {
                 log_error("could not initialize labelling: %s", strerror(-r));
                 goto exit;
@@ -1542,7 +1542,7 @@
         udev_monitor_unref(monitor);
         udev_ctrl_connection_unref(ctrl_conn);
         udev_ctrl_unref(udev_ctrl);
-        label_finish();
+        mac_selinux_finish();
         udev_unref(udev);
         log_close();
         return rc;
diff -urN systemd-216/src/udev/udev-node.c systemd-217/src/udev/udev-node.c
--- systemd-216/src/udev/udev-node.c	2014-11-03 09:35:29.696194327 -0800
+++ systemd-217/src/udev/udev-node.c	2014-10-24 04:56:24.044133834 -0700
@@ -88,11 +88,11 @@
                         err = mkdir_parents_label(slink, 0755);
                         if (err != 0 && err != -ENOENT)
                                 break;
-                        label_context_set(slink, S_IFLNK);
+                        mac_selinux_create_file_prepare(slink, S_IFLNK);
                         err = symlink(target, slink);
                         if (err != 0)
                                 err = -errno;
-                        label_context_clear();
+                        mac_selinux_create_file_clear();
                 } while (err == -ENOENT);
                 if (err == 0)
                         goto exit;
@@ -105,11 +105,11 @@
                 err = mkdir_parents_label(slink_tmp, 0755);
                 if (err != 0 && err != -ENOENT)
                         break;
-                label_context_set(slink_tmp, S_IFLNK);
+                mac_selinux_create_file_prepare(slink_tmp, S_IFLNK);
                 err = symlink(target, slink_tmp);
                 if (err != 0)
                         err = -errno;
-                label_context_clear();
+                mac_selinux_create_file_clear();
         } while (err == -ENOENT);
         if (err != 0) {
                 log_error("symlink '%s' '%s' failed: %m", target, slink_tmp);
@@ -294,21 +294,26 @@
                 /* apply SECLABEL{$module}=$label */
                 udev_list_entry_foreach(entry, udev_list_get_entry(seclabel_list)) {
                         const char *name, *label;
+                        int r;
 
                         name = udev_list_entry_get_name(entry);
                         label = udev_list_entry_get_value(entry);
 
                         if (streq(name, "selinux")) {
                                 selinux = true;
-                                if (label_apply(devnode, label) < 0)
-                                        log_error("SECLABEL: failed to set SELinux label '%s'", label);
+
+                                r = mac_selinux_apply(devnode, label);
+                                if (r < 0)
+                                        log_error("SECLABEL: failed to set SELinux label '%s': %s", label, strerror(-r));
                                 else
                                         log_debug("SECLABEL: set SELinux label '%s'", label);
 
                         } else if (streq(name, "smack")) {
                                 smack = true;
-                                if (smack_label_path(devnode, label) < 0)
-                                        log_error("SECLABEL: failed to set SMACK label '%s'", label);
+
+                                r = mac_smack_apply(devnode, label);
+                                if (r < 0)
+                                        log_error("SECLABEL: failed to set SMACK label '%s': %s", label, strerror(-r));
                                 else
                                         log_debug("SECLABEL: set SMACK label '%s'", label);
 
@@ -318,9 +323,9 @@
 
                 /* set the defaults */
                 if (!selinux)
-                        label_fix(devnode, true, false);
+                        mac_selinux_fix(devnode, true, false);
                 if (!smack)
-                        smack_label_path(devnode, NULL);
+                        mac_smack_apply(devnode, NULL);
         }
 
         /* always update timestamp when we re-use the node, like on media change events */
diff -urN systemd-216/src/update-done/update-done.c systemd-217/src/update-done/update-done.c
--- systemd-216/src/update-done/update-done.c	2014-07-29 10:51:00.747286124 -0700
+++ systemd-217/src/update-done/update-done.c	2014-10-23 12:36:56.810756232 -0700
@@ -61,7 +61,7 @@
 
                 /* The timestamp file doesn't exist yet? Then let's create it. */
 
-                r = label_context_set(path, S_IFREG);
+                r = mac_selinux_create_file_prepare(path, S_IFREG);
                 if (r < 0) {
                         log_error("Failed to set SELinux context for %s: %s",
                                   path, strerror(-r));
@@ -69,7 +69,7 @@
                 }
 
                 fd = open(path, O_CREAT|O_EXCL|O_WRONLY|O_TRUNC|O_CLOEXEC|O_NOCTTY|O_NOFOLLOW, 0644);
-                label_context_clear();
+                mac_selinux_create_file_clear();
 
                 if (fd < 0) {
 
@@ -112,7 +112,7 @@
                 return EXIT_FAILURE;
         }
 
-        r = label_init(NULL);
+        r = mac_selinux_init(NULL);
         if (r < 0) {
                 log_error("SELinux setup failed: %s", strerror(-r));
                 goto finish;
diff -urN systemd-216/test/basic.target systemd-217/test/basic.target
--- systemd-216/test/basic.target	2014-06-29 13:27:07.761305646 -0700
+++ systemd-217/test/basic.target	2014-10-27 18:19:55.429947979 -0700
@@ -11,3 +11,5 @@
 Requires=sysinit.target
 Wants=sockets.target timers.target paths.target slices.target
 After=sysinit.target sockets.target timers.target paths.target slices.target
+JobTimeoutSec=15min
+JobTimeoutAction=poweroff-force
diff -urN systemd-216/test-libsystemd-sym.c systemd-217/test-libsystemd-sym.c
--- systemd-216/test-libsystemd-sym.c	2014-08-19 14:26:12.615884172 -0700
+++ systemd-217/test-libsystemd-sym.c	2014-10-28 09:32:32.548489354 -0700
@@ -124,6 +124,7 @@
 sd_pid_notify,
 sd_pid_notifyf,
 sd_machine_get_ifindices,
+sd_session_get_desktop,
 sd_bus_default,
 sd_bus_default_user,
 sd_bus_default_system,
@@ -153,7 +154,7 @@
 sd_bus_is_open,
 sd_bus_can_send,
 sd_bus_get_server_id,
-sd_bus_get_peer_creds,
+sd_bus_get_owner_creds,
 sd_bus_get_name,
 sd_bus_send,
 sd_bus_send_to,
@@ -249,8 +250,8 @@
 sd_bus_request_name,
 sd_bus_release_name,
 sd_bus_list_names,
-sd_bus_get_owner,
-sd_bus_get_owner_machine_id,
+sd_bus_get_name_creds,
+sd_bus_get_name_machine_id,
 sd_bus_call_method,
 sd_bus_get_property,
 sd_bus_get_property_trivial,
@@ -339,6 +340,7 @@
 sd_event_loop,
 sd_event_exit,
 sd_event_now,
+sd_event_get_fd,
 sd_event_get_state,
 sd_event_get_tid,
 sd_event_get_exit_code,
@@ -346,6 +348,8 @@
 sd_event_get_watchdog,
 sd_event_source_ref,
 sd_event_source_unref,
+sd_event_source_set_name,
+sd_event_source_get_name,
 sd_event_source_set_prepare,
 sd_event_source_get_pending,
 sd_event_source_get_priority,
diff -urN systemd-216/TODO systemd-217/TODO
--- systemd-216/TODO	2014-11-03 09:35:36.949267459 -0800
+++ systemd-217/TODO	2014-11-03 09:33:48.496173927 -0800
@@ -1,6 +1,8 @@
+Fixes needed before 217:
+
+* verify that both resolved and timesyncd work OK without networkd around
+
 Bugfixes:
-* Re-enable "fsck -l" when it is ready:
-   https://bugs.freedesktop.org/show_bug.cgi?id=79576#c5
 
 * Should systemctl status \* work on all unit types, not just .service?
 
@@ -10,19 +12,15 @@
 
 * properly handle .mount unit state tracking when two mount points are stacked one on top of another on the exact same mount point.
 
-After killing 'systemd --user', systemctl restart user@... fails.
-/run/user/1000/systemd/notify has to be removed manually.
-
-ExecStart with unicode characters fails in strv_split_quoted:
+* ExecStart with unicode characters fails in strv_split_quoted:
 
           [Service]
           Environment=ONE='one' "TWO='two two' too" THREE=
           ExecStart=/bin/python3 -c 'import sys;print(sys.argv)' $ONE $TWO $THREE
 
-MEMORY return code is overloaded for syntax errors in the commandline.
-str_split_quoted() should return a real return code, so spawn_child can
-report the failure properly.
-
+* MEMORY return code is overloaded for syntax errors in the commandline.
+  str_split_quoted() should return a real return code, so spawn_child can
+  report the failure properly.
 
 External:
 * Fedora: add an rpmlint check that verifies that all unit files in the RPM are listed in %systemd_post macros.
@@ -40,19 +38,42 @@
 
 Features:
 
+* journald: allow per-priority and per-service retention times when rotating/vacuuming
+
+* introduce systemd-timesync-wait.service or so to sync on an NTP fix?
+
+* systemd --user should issue sd_notify() upon reaching basic.target, not on becoming idle
+
+* configure.ac pretends dbus was optional but actually hardcodes use of dbus' pkg-config file to determine various dbus dirs such as policy and activation dirs
+
+* consider showing the unit names during boot up in the status output, not just the unit descriptions
+
+* send SIGABRT when a service watchdog is triggered, by default, so that we acquire a backtrace of the hang.
+
+* dhcp: do we allow configuring dhcp routes on interfaces that are not the one we got the dhcp info from?
+
+* maybe allow timer units with an empty Units= setting, so that they
+  can be used for resuming the system but nothing else.
+
+* what to do about udev db binary stability for apps?
+
+* maybe provide an API to allow migration of foreign PIDs into existing scopes.
+
+* kdbus: maybe rename "connection name" concept to something that doesn't reuse the word "name"?
+
+* PID 1 doesn't apply nspawns devices cgroup policy
+
+* rework journal-send.c to use memfds for large blobs if they are available instead of unlinked files in /tmp. Also, if we detect that the kernel knows memfds, refuse anything but sealed memfds.
+
 * maybe support a new very "soft" reboot mode, that simply kills all processes, disassembles everything, flushes /run and sysvipc, and then reexecs systemd again
 
 * man: document that corrupted journal files is nothing to act on
 
-* systemctl isolate should use ".target" as completion suffix, not ".service"
-
 * bus-proxy: when passing messages from kdbus, make sure we properly
   handle the case where a large number of fds is appended that we
   cannot pass into sendmsg() of the AF_UNIX sokcet (which only accepts
   253 messages)
 
-* check for validity of ucred fields in bus-proxy, like we do in journald
-
 * busctl: add a pcap writer, using LINKTYPE_DBUS/231
 
 * man: maybe use the word "inspect" rather than "introspect"?
@@ -67,8 +88,6 @@
 
 * maybe add "systemctl edit" that copies unit files from /usr/lib/systemd/system to /etc/systemd/system and invokes vim on them
 
-* dbus: add new message hdr field for allowing interactive auth, write spec for it. update dbus spec to mandate that unknown flags *must* be ignored...
-
 * maybe introduce AssertXYZ= similar to ConditionXYZ= that causes a unit to fail (instead of skipping it) if some condition is not true...
 
 * remove multi-seat-x now
@@ -77,10 +96,6 @@
 
 * exponential backoff in timesyncd and resolved when we cannot reach a server
 
-* apply start timeout during the "initializing" manager state only,
-  instead of both "initializing" and "starting". maybe rename the
-  timeout to "initialization-timeout" then or so?
-
 * journald: make use of uid-range.h to managed uid ranges to split
   journals in.
 
@@ -97,8 +112,6 @@
 
 * merge ~/.local/share and ~/.local/lib into one similar /usr/lib and /usr/share....
 
-* remove readahead in 217
-
 * journald: allows specification of UID range for splitting up journal files
 
 * systemd.show_status= should probably have a mode where only failed
@@ -121,6 +134,8 @@
     to clients. It should also pass on its own timezone information.
   - provide a way to define a per-network interface default metric value
     for all routes to it. possibly a second default for DHCP routes.
+  - allow Name= to be specified repeatedly in the [Match] section. Maybe also
+    support Name=foo*|bar*|baz ?
 
 * resolved:
   - put networkd events and rtnl events at a higher priority, so that
@@ -167,8 +182,6 @@
 
 * journalctl: add the ability to look for the most recent process of a binary. journalctl /usr/bin/X11 --pid=-1 or so...
 
-* set NOTIFY_SOCKET also for control processes
-
 * mount_cgroup_controllers(): symlinks need to get the label applied
 
 * For timer units: add some mechanisms so that timer units that trigger immediately on boot do not have the services
@@ -294,7 +307,6 @@
        - kdbus mapping
        - NameLost/NameAcquired obsolete
        - GVariant
-       - "const" properties (posted)
        - path escaping
   - update systemd.special(7) to mention that dbus.socket is only about the compatibility socket now
   - test bloom filter generation indexes
@@ -773,8 +785,10 @@
 
 * register catalog database signature as file magic
 
-* zsh shell completion: <command> <verb> -<TAB> should complete options, but currently
-  does not
+* zsh shell completion:
+  - <command> <verb> -<TAB> should complete options, but currently does not
+  - systemctl add-wants,add-requires
+
 
 Regularly:
 
diff -urN systemd-216/units/basic.target systemd-217/units/basic.target
--- systemd-216/units/basic.target	2014-06-29 13:27:07.761305646 -0700
+++ systemd-217/units/basic.target	2014-11-03 09:33:49.254181570 -0800
@@ -8,6 +8,8 @@
 [Unit]
 Description=Basic System
 Documentation=man:systemd.special(7)
+
 Requires=sysinit.target
+After=sysinit.target
 Wants=sockets.target timers.target paths.target slices.target
-After=sysinit.target sockets.target timers.target paths.target slices.target
+After=sockets.target paths.target slices.target
diff -urN systemd-216/units/systemd-firstboot.service.in systemd-217/units/systemd-firstboot.service.in
--- systemd-216/units/systemd-firstboot.service.in	2014-11-03 09:35:23.975136641 -0800
+++ systemd-217/units/systemd-firstboot.service.in	2014-11-03 09:33:48.263171578 -0800
@@ -10,8 +10,9 @@
 Documentation=man:systemd-firstboot(1)
 DefaultDependencies=no
 Conflicts=shutdown.target
-After=systemd-readahead-collect.service systemd-readahead-replay.service systemd-remount-fs.service systemd-sysusers.service
-Before=sysinit.target shutdown.target
+After=systemd-readahead-collect.service systemd-readahead-replay.service
+After=systemd-remount-fs.service
+Before=systemd-sysusers.service sysinit.target shutdown.target
 ConditionPathIsReadWrite=/etc
 ConditionFirstBoot=yes
 
diff -urN systemd-216/units/systemd-journald.service.in systemd-217/units/systemd-journald.service.in
--- systemd-216/units/systemd-journald.service.in	2014-06-12 16:15:55.948827245 -0700
+++ systemd-217/units/systemd-journald.service.in	2014-10-22 10:12:06.748818217 -0700
@@ -20,7 +20,7 @@
 RestartSec=0
 NotifyAccess=all
 StandardOutput=null
-CapabilityBoundingSet=CAP_SYS_ADMIN CAP_DAC_OVERRIDE CAP_SYS_PTRACE CAP_SYSLOG CAP_AUDIT_CONTROL CAP_CHOWN CAP_DAC_READ_SEARCH CAP_FOWNER CAP_SETUID CAP_SETGID
+CapabilityBoundingSet=CAP_SYS_ADMIN CAP_DAC_OVERRIDE CAP_SYS_PTRACE CAP_SYSLOG CAP_AUDIT_CONTROL CAP_CHOWN CAP_DAC_READ_SEARCH CAP_FOWNER CAP_SETUID CAP_SETGID CAP_MAC_OVERRIDE
 WatchdogSec=1min
 
 # Increase the default a bit in order to allow many simultaneous
diff -urN systemd-216/units/systemd-journal-flush.service.in systemd-217/units/systemd-journal-flush.service.in
--- systemd-216/units/systemd-journal-flush.service.in	2013-08-13 13:02:52.811756297 -0700
+++ systemd-217/units/systemd-journal-flush.service.in	2014-11-03 09:33:49.273181762 -0800
@@ -6,13 +6,16 @@
 #  (at your option) any later version.
 
 [Unit]
-Description=Trigger Flushing of Journal to Persistent Storage
+Description=Flush Journal to Persistent Storage
 Documentation=man:systemd-journald.service(8) man:journald.conf(5)
 DefaultDependencies=no
 Requires=systemd-journald.service
-After=systemd-journald.service local-fs.target remote-fs.target
-Before=systemd-user-sessions.service
+After=systemd-journald.service
+After=systemd-remount-fs.service
+Before=systemd-user-sessions.service systemd-tmpfiles-setup.service
+RequiresMountsFor=/var/log/journal
 
 [Service]
-ExecStart=@rootbindir@/systemctl kill --kill-who=main --signal=SIGUSR1 systemd-journald.service
+ExecStart=@rootbindir@/journalctl --flush
 Type=oneshot
+RemainAfterExit=yes
diff -urN systemd-216/units/systemd-tmpfiles-setup-dev.service.in systemd-217/units/systemd-tmpfiles-setup-dev.service.in
--- systemd-216/units/systemd-tmpfiles-setup-dev.service.in	2014-07-03 18:24:41.951585641 -0700
+++ systemd-217/units/systemd-tmpfiles-setup-dev.service.in	2014-11-03 09:33:48.265171598 -0800
@@ -17,4 +17,4 @@
 [Service]
 Type=oneshot
 RemainAfterExit=yes
-ExecStart=@rootbindir@/systemd-tmpfiles --prefix=/dev --create
+ExecStart=@rootbindir@/systemd-tmpfiles --prefix=/dev --create --boot
diff -urN systemd-216/units/systemd-udev-hwdb-update.service.in systemd-217/units/systemd-udev-hwdb-update.service.in
--- systemd-216/units/systemd-udev-hwdb-update.service.in	2014-06-16 03:24:44.204292022 -0700
+++ systemd-217/units/systemd-udev-hwdb-update.service.in	2014-11-03 09:33:48.265171598 -0800
@@ -13,6 +13,9 @@
 After=systemd-readahead-collect.service systemd-readahead-replay.service systemd-remount-fs.service
 Before=sysinit.target shutdown.target systemd-update-done.service
 ConditionNeedsUpdate=/etc
+ConditionPathExists=|!@udevlibexecdir@/hwdb.bin
+ConditionPathExists=|/etc/udev/hwdb.bin
+ConditionDirectoryNotEmpty=|/etc/udev/hwdb.d/
 
 [Service]
 Type=oneshot
diff -urN systemd-216/units/timers.target systemd-217/units/timers.target
--- systemd-216/units/timers.target	2013-08-13 13:02:52.832756455 -0700
+++ systemd-217/units/timers.target	2014-11-03 09:33:49.254181570 -0800
@@ -8,3 +8,6 @@
 [Unit]
 Description=Timers
 Documentation=man:systemd.special(7)
+
+DefaultDependencies=no
+Conflicts=shutdown.target
